# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin

try:
    from urllib import urlencode
except ImportError:
    from urllib.parse import urlencode
try:
    from urlparse import urlparse, parse_qs
except ImportError:
    from urllib.parse import urlparse, parse_qs
import sys
import requests

if sys.version_info < (2, 7) or (sys.version_info >= (3, 0) and sys.version_info < (3, 1)):
    import simplejson as json
    from simplejson import OrderedDict
else:
    import json
    from collections import OrderedDict
import localau


def item(title, para, isFolder=True):
    listitem = xbmcgui.ListItem(title)
    if 'title' not in para:
        para['title'] = title
    for k in para:
        if isinstance(para[k], unicode):
            para[k] = para[k].encode('utf-8')
    xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(para), listitem, isFolder)


def play(title, url, header={}):
    listitem = xbmcgui.ListItem(title)
    h = []
    if header:
        url += '|' + urlencode(header)
    xbmc.Player().play(url, listitem)


def sub1(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    l = len(p)
    if o.path[-5:] == '.m3u8':
        return False
    if o.netloc in ('www.localmv.com', 'www.localmv1.com', 'www.localmv.tv'):
        if l > 1 and p[1] == 'play':
            return False
    if o.netloc in ('sports.localau.com', 'www.tiyu6.tv'):
        if l > 1 and p[1] == 'play':
            return False
    return True


def sub2(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    l = len(p)
    if o.path[-5:] == '.m3u8':
        play('', url)
        return
    if o.netloc in ('sports.localau.com', 'www.tiyu6.tv'):
        if l < 2:
            xbmcgui.Dialog().ok('错误', '错误代码: localau 021')
            return
        if p[1] == 'game':
            ret = localau.game(url)
        elif p[1] == 'play':
            ret = localau.sport(url)
        else:
            xbmcgui.Dialog().ok('错误', '错误代码: localau 022')
            return
    elif o.netloc in ('www.localmv.com', 'www.localmv1.com', 'www.localmv.tv'):
        if l < 2:
            xbmcgui.Dialog().ok('错误', '错误代码: localau 023')
            return
        if p[1] == 'video':
            ret = localau.video(url)
        elif p[1] == 'play':
            ret = localau.play(url)
        else:
            xbmcgui.Dialog().ok('错误', '错误代码: localau 024')
            return
    else:
        xbmcgui.Dialog().ok('错误', '错误代码: localau 020')
        return
    if 'code' in ret:
        xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
        return
    if 'item' in ret:
        for elem in ret['item']:
            item(elem['title'], elem, sub1(elem['url']))
        xbmcplugin.endOfDirectory(handle)
    if 'url' in ret:
        if 'header' in ret:
            play('', ret['url']['m3u8'], ret['header'])
        else:
            play('', ret['url']['m3u8'])


def sub3(content):
    try:
        data = json.loads(content, object_pairs_hook=OrderedDict)
    except:
        xbmcgui.Dialog().ok('错误', '错误代码: localau 030')
        return
    for k in data:
        if isinstance(data[k], dict):
            item(k, {'json': json.dumps(data[k])})
        else:
            url = data[k]
            item(k, {'url': url}, sub1(url))
    xbmcplugin.endOfDirectory(handle)


def category(cat, page):
    ret = localau.category(cat, page)
    if 'code' in ret:
        xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
        return
    for elem in ret['item']:
        item(elem['title'], elem)
    xbmcplugin.endOfDirectory(handle)

def sports():
    ret = localau.sports()
    if 'code' in ret:
        xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
        return
    for elem in ret['item']:
        item(elem['title'], elem)
    xbmcplugin.endOfDirectory(handle)


def get_node(url):
    try:
        content = requests.get(url).text
    except:
        xbmcgui.Dialog().ok('错误', '错误代码: localau 010')
        return
    sub3(content)


handle = int(sys.argv[1])
url = sys.argv[2]
if not url:
    item('电影', {'category': 'dianying', 'page': 1})
    item('电视剧', {'category': 'dianshiju', 'page': 1})
    item('综艺', {'category': 'zongyi', 'page': 1})
    item('动漫', {'category': 'dongman', 'page': 1})
    item('纪录片', {'category': 'document', 'page': 1})
    item('体育直播', {'sports': True})
    get_node('http://ims.tian-le.com/localau.json')
else:
    o = urlparse(url)
    q = parse_qs(o.query)
    if 'json' in q:
        sub3(q['json'][0])
    if 'category' in q:
        category(q['category'][0], int(q['page'][0]))
    if 'sports' in q:
        sports()
    if 'url' in q:
        sub2(q['url'][0])
